#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netinet/tcp.h>

#include "Controller.h"


static const unsigned int PORT=7777;
static const unsigned int RCVBUFSIZE=8192;
int sock;


void error_exit(const char *errorMessage) {
  fprintf(stderr, "%s: %s\n", errorMessage, strerror(errno));
  exit(EXIT_FAILURE);
}



int main( int argc, char **argv) {
  struct sockaddr_in server;
  struct hostent *host_info;
  unsigned long addr;

  if (argc < 2) {
      error_exit("usage: client server-ip\n");
  }

  sock = socket( AF_INET, SOCK_STREAM, 0 );
  if (sock < 0) {
      error_exit( "Fehler beim Anlegen eines Sockets");
  }

  memset( &server, 0, sizeof (server));
  if ((addr = inet_addr( argv[1])) != INADDR_NONE) {
      /* argv[1] ist eine numerische IP-Adresse */
      memcpy( (char *)&server.sin_addr, &addr, sizeof(addr));
  }
  else {
      host_info = gethostbyname(argv[1]);
      if (NULL == host_info)
          error_exit("Unbekannter Server");
      memcpy( (char *)&server.sin_addr,
              host_info->h_addr, host_info->h_length );
  }
  server.sin_family = AF_INET;
  server.sin_port = htons( PORT );
  const int flag = 1;
  setsockopt(sock,IPPROTO_TCP,TCP_NODELAY,(char *) &flag,sizeof(int));

  if ( connect(sock,(struct sockaddr*)&server,sizeof(server)) < 0 ) {
      error_exit("Kann keine Verbindung zum Server herstellen");
  }

  // jetzt geht's los!
  Controller myController(sock);
  myController.run();

  close(sock);
  return EXIT_SUCCESS;
}
